within ;
package tonka "basic set of models for"
  extends Modelica;
  model HeatGen "Starting point for component heat"
    parameter Modelica.SIunits.HeatCapacity Cap
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond
      "Constant thermal conductance of material";
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = Cap) annotation(Placement(transformation(extent = {{-30,118},{-10,138}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{18,84},{38,104}})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow prescribedHeatFlow annotation(Placement(transformation(extent = {{-50,82},{-30,102}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a annotation(Placement(transformation(extent = {{64,84},{84,104}})));
    Modelica.Blocks.Interfaces.RealInput heatGen annotation(Placement(transformation(extent = {{-90,82},{-68,104}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-66,-60},{-46,-40}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p2
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-50,-60},{-30,-40}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p3
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-60,-42},{-40,-22}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p4
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-4,-30},{16,-10}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p5
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-6,-66},{14,-46}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p6
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{30,-12},{50,8}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p7
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{66,60},{86,80}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 1000000) annotation(Placement(transformation(extent = {{-52,-90},{-32,-70}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor1(R = 1000000) annotation(Placement(transformation(extent = {{-38,-34},{-18,-14}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor2(R = 1000000) annotation(Placement(transformation(extent = {{6,-80},{26,-60}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor3(R = 1000000) annotation(Placement(transformation(extent = {{16,-32},{36,-12}})));
    Modelica.Electrical.Analog.Basic.Ground ground annotation(Placement(transformation(extent = {{-30,-116},{-10,-96}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor4(R = 1000000) annotation(Placement(transformation(extent = {{46,-32},{66,-12}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor5(R = 1000000) annotation(Placement(transformation(extent = {{-38,-74},{-18,-54}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor6(R = 1000000) annotation(Placement(transformation(extent = {{72,-22},{92,-2}})));
    Modelica.Electrical.Analog.Sources.PulseVoltage pbase1(V = 3.3, width = 50, period = 0.1, startTime = 0.0) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-88,20})));
    Modelica.Electrical.Analog.Interfaces.PositivePin B0
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-18,8},{2,28}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.PulseVoltage pbase2(V = 3.3, width = 50, period = 0.1, startTime = 0.05) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-68,10})));
    Modelica.Electrical.Analog.Basic.Resistor resistor7(R = 1000) annotation(Placement(transformation(extent = {{-46,12},{-32,26}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor8(R = 1000) annotation(Placement(transformation(extent = {{-70,28},{-56,42}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin B5
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-8,18},{12,38}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B2
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{4,30},{24,50}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B3
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{16,40},{36,60}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B4
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{28,50},{48,70}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-96,42},{-76,62}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B6
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-78,52},{-58,72}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B7
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-62,64},{-42,84}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B8
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-44,64},{-24,84}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin B9
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-28,62},{-8,82}}, rotation = 0)));
  equation
    connect(prescribedHeatFlow.port,heatCapacitor.port) annotation(Line(points = {{-30,92},{-20,92},{-20,118}}, color = {191,0,0}, smooth = Smooth.None));
    connect(prescribedHeatFlow.port,thermalConductor.port_a) annotation(Line(points = {{-30,92},{12,92},{12,94},{18,94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,port_a) annotation(Line(points = {{38,94},{74,94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(prescribedHeatFlow.Q_flow,heatGen) annotation(Line(points = {{-50,92},{-55.5,92},{-55.5,93},{-79,93}}, color = {0,0,127}, smooth = Smooth.None));
    connect(port_a,port_a) annotation(Line(points = {{74,94},{74,94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(p1,resistor.p) annotation(Line(points = {{-56,-50},{-54,-50},{-54,-80},{-52,-80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p3,resistor1.p) annotation(Line(points = {{-50,-32},{-50,-24},{-38,-24}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p4,resistor3.p) annotation(Line(points = {{6,-20},{6,-23},{16,-23},{16,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p5,resistor2.p) annotation(Line(points = {{4,-56},{4,-70},{6,-70}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,ground.p) annotation(Line(points = {{-32,-80},{-16,-80},{-16,-96},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p2,resistor5.p) annotation(Line(points = {{-40,-50},{-40,-64},{-38,-64}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor5.n,ground.p) annotation(Line(points = {{-18,-64},{-12,-64},{-12,-96},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor1.n,ground.p) annotation(Line(points = {{-18,-24},{-12,-24},{-12,-96},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor2.n,ground.p) annotation(Line(points = {{26,-70},{26,-98},{-20,-98},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor3.n,ground.p) annotation(Line(points = {{36,-22},{36,-98},{-20,-98},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p6,resistor4.p) annotation(Line(points = {{40,-2},{44,-2},{44,-22},{46,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor6.p,p7) annotation(Line(points = {{72,-12},{69,-12},{69,70},{76,70}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor6.n,ground.p) annotation(Line(points = {{92,-12},{92,-98},{-20,-98},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor4.n,ground.p) annotation(Line(points = {{66,-22},{66,-98},{-20,-98},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pbase1.n,ground.p) annotation(Line(points = {{-88,10},{-88,-96},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pbase2.n,ground.p) annotation(Line(points = {{-68,0},{-70,0},{-70,-96},{-20,-96}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pbase2.p,resistor7.p) annotation(Line(points = {{-68,20},{-58,20},{-58,19},{-46,19}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pbase1.p,resistor8.p) annotation(Line(points = {{-88,30},{-72,30},{-72,35},{-70,35}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor8.n,B8) annotation(Line(points = {{-56,35},{-46,35},{-46,74},{-34,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B7,B8) annotation(Line(points = {{-52,74},{-34,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B9,B8) annotation(Line(points = {{-18,72},{-32,72},{-32,60},{-46,60},{-46,74},{-34,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B6,B8) annotation(Line(points = {{-68,62},{-46,62},{-46,74},{-34,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B1,B8) annotation(Line(points = {{-86,52},{-66,52},{-66,54},{-46,54},{-46,74},{-34,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor7.n,B0) annotation(Line(points = {{-32,19},{-22,19},{-22,18},{-8,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B5,B0) annotation(Line(points = {{2,28},{-4,28},{-4,18},{-8,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B2,B0) annotation(Line(points = {{14,40},{-24,40},{-24,20},{-22,19},{-22,18},{-8,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B3,B0) annotation(Line(points = {{26,50},{-22,50},{-22,40},{-24,40},{-24,20},{-22,19},{-22,18},{-8,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B4,B0) annotation(Line(points = {{38,60},{-12,60},{-12,50},{-22,50},{-22,40},{-24,40},{-24,20},{-22,19},{-22,18},{-8,18}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{120,140}}), graphics), Icon(coordinateSystem(extent = {{-100,-100},{120,140}})));
  end HeatGen;

  model HeatSink "Example Heat sink"
    parameter Modelica.SIunits.ThermalConductance G_toBoard
      "Chip to Board, Constant thermal conductance of material,";
    parameter Modelica.SIunits.ThermalConductance G_toEnv
      "Board to Environment, Constant thermal conductance of material";
    parameter Modelica.SIunits.HeatCapacity Cap
      "Board Heat capacity of element (= cp*m)";
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = Cap) annotation(Placement(transformation(extent = {{-16,4},{4,24}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a annotation(Placement(transformation(extent = {{-74,-2},{-54,18}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = G_toEnv) annotation(Placement(transformation(extent = {{-6,-62},{14,-42}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor1(G = G_toBoard) annotation(Placement(transformation(extent = {{-38,-28},{-18,-8}})));
    Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T = 293.15) annotation(Placement(transformation(extent = {{-40,-62},{-20,-42}})));
  equation
    connect(port_a,thermalConductor1.port_a) annotation(Line(points = {{-64,8},{-66,8},{-66,-18},{-38,-18}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,thermalConductor1.port_b) annotation(Line(points = {{-6,4},{-6,-18},{-18,-18}}, color = {191,0,0}, smooth = Smooth.None));
    connect(fixedTemperature.port,thermalConductor.port_a) annotation(Line(points = {{-20,-52},{-6,-52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,thermalConductor1.port_b) annotation(Line(points = {{14,-52},{26,-52},{26,-18},{-18,-18}}, color = {191,0,0}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end HeatSink;

  model simpleThermalCircuit
    HeatGen heatGen(Cap = 10, Gcond = 3) annotation(Placement(transformation(extent = {{-50,24},{-30,44}})));
    HeatSink heatSink(G_toBoard = 2, G_toEnv = 6, Cap = 30) annotation(Placement(transformation(extent = {{6,26},{26,46}})));
    Modelica.Blocks.Sources.Pulse pulse(amplitude = 100, period = 6, offset = 100) annotation(Placement(transformation(extent = {{-92,24},{-72,44}})));
  equation
    connect(heatGen.port_a,heatSink.port_a) annotation(Line(points = {{-33.6,37.4},{-13.8,37.4},{-13.8,36.8},{9.6,36.8}}, color = {191,0,0}, smooth = Smooth.None));
    connect(pulse.y,heatGen.heatGen) annotation(Line(points = {{-71,34},{-60,34},{-60,33.5},{-48.9,33.5}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end simpleThermalCircuit;

  model Meter "Voltage and Current Meter"
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-26,28},{-6,48}})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-24,-20},{-4,0}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin p "positive pin" annotation(Placement(transformation(extent = {{-94,40},{-74,60}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "negative pin" annotation(Placement(transformation(extent = {{40,40},{60,60}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealOutput v
      "Voltage between pin p and n (= p.v - n.v) as output signal"                                       annotation(Placement(transformation(origin = {60,8}, extent = {{10,-10},{-10,10}}, rotation = 180)));
    Modelica.Blocks.Interfaces.RealOutput i
      "Voltage between pin p and n (= p.v - n.v) as output signal"                                       annotation(Placement(transformation(origin = {60,-26}, extent = {{10,-10},{-10,10}}, rotation = 180)));
  equation
    connect(p,voltageSensor.p) annotation(Line(points = {{-84,50},{-56,50},{-56,38},{-26,38}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p,currentSensor.p) annotation(Line(points = {{-84,50},{-54,50},{-54,-10},{-24,-10}}, color = {0,0,255}, smooth = Smooth.None));
    connect(n,voltageSensor.n) annotation(Line(points = {{50,50},{22,50},{22,38},{-6,38}}, color = {0,0,255}, smooth = Smooth.None));
    connect(n,currentSensor.n) annotation(Line(points = {{50,50},{24,50},{24,-10},{-4,-10}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.v,v) annotation(Line(points = {{-16,28},{18,28},{18,8},{60,8}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,i) annotation(Line(points = {{-14,-20},{18,-20},{18,-26},{60,-26}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end Meter;

  model DualOpAmp "Dual Op Amps"
    extends Modelica.Electrical.Analog;
    Modelica.Electrical.Analog.Ideal.IdealOpAmpLimited A_OPAmp annotation(Placement(transformation(extent = {{-48,46},{-28,66}})));
    Modelica.Electrical.Analog.Ideal.IdealOpAmpLimited B_OPAmp annotation(Placement(transformation(extent = {{-48,16},{-28,36}})));
    Modelica.Electrical.Analog.Interfaces.NegativePin aNeg
      "Negative pin of the input port"                                                      annotation(Placement(transformation(extent = {{-94,64},{-74,84}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin aPos
      "Positive pin of the input port"                                                      annotation(Placement(transformation(extent = {{-94,38},{-74,58}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin aOut "Output pin" annotation(Placement(transformation(extent = {{-6,46},{14,66}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin bOut "Output pin" annotation(Placement(transformation(extent = {{-6,18},{14,38}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin bPos
      "Positive pin of the input port"                                                      annotation(Placement(transformation(extent = {{-94,-4},{-74,16}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin bNeg
      "Negative pin of the input port"                                                      annotation(Placement(transformation(extent = {{-94,16},{-74,36}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin VMax
      "Positive pin of the input port"                                                      annotation(Placement(transformation(extent = {{-48,76},{-28,96}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin VMin
      "Negative pin of the input port"                                                      annotation(Placement(transformation(extent = {{-50,-20},{-30,0}}, rotation = 0)));
  equation
    connect(aNeg,A_OPAmp.in_n) annotation(Line(points = {{-84,74},{-70,74},{-70,61},{-48,61}}, color = {0,0,255}, smooth = Smooth.None));
    connect(aPos,A_OPAmp.in_p) annotation(Line(points = {{-84,48},{-68,48},{-68,51},{-48,51}}, color = {0,0,255}, smooth = Smooth.None));
    connect(aOut,A_OPAmp.out) annotation(Line(points = {{4,56},{-28,56}}, color = {0,0,255}, smooth = Smooth.None));
    connect(bNeg,B_OPAmp.in_n) annotation(Line(points = {{-84,26},{-66,26},{-66,31},{-48,31}}, color = {0,0,255}, smooth = Smooth.None));
    connect(bPos,B_OPAmp.in_p) annotation(Line(points = {{-84,6},{-66,6},{-66,21},{-48,21}}, color = {0,0,255}, smooth = Smooth.None));
    connect(B_OPAmp.out,bOut) annotation(Line(points = {{-28,26},{-14,26},{-14,28},{4,28}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VMax,A_OPAmp.VMax) annotation(Line(points = {{-38,86},{-38,63}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VMax,B_OPAmp.VMax) annotation(Line(points = {{-38,86},{-18,86},{-18,40},{-38,40},{-38,33}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VMin,B_OPAmp.VMin) annotation(Line(points = {{-40,-10},{-40,19},{-38,19}}, color = {0,0,255}, smooth = Smooth.None));
    connect(A_OPAmp.VMin,B_OPAmp.VMin) annotation(Line(points = {{-38,49},{-22,49},{-22,10},{-40,10},{-40,19},{-38,19}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end DualOpAmp;

  model MeteredLoad "Load Resistor with a Current Meter"
    parameter Modelica.SIunits.Resistance Rval(start = 1)
      "Resistance at temperature T_ref";
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-20,46},{0,66}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin p "positive pin" annotation(Placement(transformation(extent = {{-84,50},{-64,70}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "negative pin" annotation(Placement(transformation(extent = {{50,50},{70,70}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealOutput i
      "Voltage between pin p and n (= p.v - n.v) as output signal"                                       annotation(Placement(transformation(origin = {70,-16}, extent = {{10,-10},{-10,10}}, rotation = 180)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = Rval) annotation(Placement(transformation(extent = {{-52,48},{-32,68}})));
  equation
    connect(n,currentSensor.n) annotation(Line(points = {{60,60},{34,60},{34,56},{0,56}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,i) annotation(Line(points = {{-10,46},{28,46},{28,-16},{70,-16}}, color = {0,0,127}, smooth = Smooth.None));
    connect(p,resistor.p) annotation(Line(points = {{-74,60},{-62,60},{-62,58},{-52,58}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,currentSensor.p) annotation(Line(points = {{-32,58},{-26,58},{-26,56},{-20,56}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end MeteredLoad;

  model null "get around rules of cyphy2modelica"
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-56,-50},{-36,-30}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p2
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-34,-48},{-14,-28}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p3
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-72,46},{-52,66}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p4
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-72,26},{-52,46}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p5
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{2,-58},{22,-38}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p6
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{58,-32},{78,-12}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p7
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{50,-52},{70,-32}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 10000000) annotation(Placement(transformation(extent = {{20,-32},{40,-12}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor1(R = 10000000) annotation(Placement(transformation(extent = {{-26,30},{-6,50}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor2(R = 10000000) annotation(Placement(transformation(extent = {{-28,10},{-8,30}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor3(R = 10000000) annotation(Placement(transformation(extent = {{32,-78},{52,-58}})));
  equation
    connect(p1,resistor2.p) annotation(Line(points = {{-46,-40},{-48,-40},{-48,20},{-28,20}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p2,resistor2.n) annotation(Line(points = {{-24,-38},{-24,2},{-4,2},{-4,20},{-8,20}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p3,resistor1.p) annotation(Line(points = {{-62,56},{-44,56},{-44,40},{-26,40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p4,resistor1.n) annotation(Line(points = {{-62,36},{0,36},{0,40},{-6,40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p5,resistor.p) annotation(Line(points = {{12,-48},{12,-22},{20,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,p6) annotation(Line(points = {{40,-22},{68,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p5,resistor3.p) annotation(Line(points = {{12,-48},{22,-48},{22,-68},{32,-68}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor3.n,p7) annotation(Line(points = {{52,-68},{58,-68},{58,-42},{60,-42}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end null;

  model HeatGen_table "Starting point for component heat"
    parameter Modelica.SIunits.HeatCapacity Cap
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond
      "Constant thermal conductance of material";
    parameter String  FName "File name for power profile)";

    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermCond(G=Gcond)      annotation(Placement(transformation(extent={{10,-10},
              {30,10}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a annotation(Placement(transformation(extent={{52,-10},
              {72,10}})));
    Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(tableOnFile = true, tableName = "tab1", fileName = FName, smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments,
      extrapolation=Modelica.Blocks.Types.Extrapolation.Periodic)                                                                                                     annotation(Placement(transformation(extent={{-90,-10},
              {-70,10}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCap(C=Cap)           annotation(Placement(visible = true, transformation(origin={-12,38},   extent = {{-10,-10},{10,10}}, rotation = 0)));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow wattsGenerated     annotation(Placement(visible = true, transformation(origin = {-40,0}, extent = {{-10,-10},{10,10}}, rotation = 0)));
  equation
    connect(combiTimeTable.y[1], wattsGenerated.Q_flow)    annotation(Line(points={{-69,0},
            {-61.9958,0},{-61.9958,-0.424628},{-50,-0.424628},{-50,0}}));
    connect(wattsGenerated.port, thermCond.port_a)           annotation(Line(points={{-30,0},
            {2,0},{10,0}},                                                                                           color = {191,0,0}));
    connect(thermCond.port_b, port_a)       annotation(Line(points={{30,0},{62,0}},     color = {191,0,0}, smooth = Smooth.None));
    connect(port_a,port_a) annotation(Line(points={{62,0},{62,0}},     color = {191,0,0}, smooth = Smooth.None));
    connect(heatCap.port, thermCond.port_a)              annotation (Line(
        points={{-12,28},{-12,0},{10,0}},
        color={191,0,0},
        smooth=Smooth.None));
    annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {0.1,0.1})), Diagram(coordinateSystem(extent={{-100,
              -100},{100,100}},                                                                                                    preserveAspectRatio=false,  initialScale = 0.1, grid = {2,2}),
          graphics),
               Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end HeatGen_table;

  model TablePlayer "Play a data table"
    extends Modelica;
    Modelica.Blocks.Interfaces.RealOutput y[nout]
      "Connector of Real output signals"                                             annotation(Placement(transformation(extent = {{-30,32},{-10,52}}, rotation = 0)));
    Modelica.Blocks.Sources.TimeTable timeTable annotation(Placement(transformation(extent = {{-82,36},{-62,56}})));
  equation
    connect(timeTable.y,y[1]) annotation(Line(points = {{-61,46},{-44,46},{-44,42},{-20,42}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end TablePlayer;

  model DC_DC_Conv "SimpleDC DC Converter following Torrey and Selamogullari"
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-102,8},{-82,28}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-82,-44},{-102,-24}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{78,8},{98,28}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{98,-44},{78,-24}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalCurrent signalCurrent annotation(Placement(transformation(extent = {{-60,8},{-40,28}})));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {28,-6})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 0, origin = {58,8})));
    Modelica.Blocks.Sources.Constant VoltageOut(k = 3.3) annotation(Placement(transformation(extent = {{0,-50},{20,-30}})));
    Modelica.Blocks.Tables.CombiTable1D Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {56,42})));
    Modelica.Blocks.Math.Division division annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {14,32})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-22,38})));
    Modelica.Blocks.Sources.Constant InputQuiescentCurrent(k = 0.06) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {26,64})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow surrogateHeatGen annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-2,-72})));
    Modelica.Blocks.Tables.CombiTable1D HeatGen(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {34,-72})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort annotation(Placement(transformation(extent = {{-46,-88},{-26,-68}})));
  equation
    connect(p,signalCurrent.p) annotation(Line(points = {{-92,18},{-60,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalCurrent.n,n) annotation(Line(points = {{-40,18},{-38,18},{-38,-34},{-92,-34}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.p,currentSensor.p) annotation(Line(points = {{28,4},{38,4},{38,8},{48,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.n,p1) annotation(Line(points = {{68,8},{80,8},{80,18},{88,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n1) annotation(Line(points = {{28,-16},{28,-34},{88,-34}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VoltageOut.y,signalVoltage.v) annotation(Line(points = {{21,-40},{42,-40},{42,-6},{35,-6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,Efficiency.u[1]) annotation(Line(points = {{58,-2},{76,-2},{76,42},{68,42}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.y,add.u1) annotation(Line(points = {{3,32},{-10,32}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.y,signalCurrent.i) annotation(Line(points = {{-33,38},{-50,38},{-50,25}}, color = {0,0,127}, smooth = Smooth.None));
    connect(InputQuiescentCurrent.y,add.u2) annotation(Line(points = {{15,64},{0,64},{0,44},{-10,44}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,division.u1) annotation(Line(points = {{58,-2},{72,-2},{72,26},{26,26}}, color = {0,0,127}, smooth = Smooth.None));
    connect(Efficiency.y[1],division.u2) annotation(Line(points = {{45,42},{32,42},{32,38},{26,38}}, color = {0,0,127}, smooth = Smooth.None));
    connect(HeatGen.y[1],surrogateHeatGen.Q_flow) annotation(Line(points = {{23,-72},{8,-72}}, color = {0,0,127}, smooth = Smooth.None));
    connect(surrogateHeatGen.port,HeatPort) annotation(Line(points = {{-12,-72},{-24,-72},{-24,-78},{-36,-78}}, color = {191,0,0}, smooth = Smooth.None));
    connect(currentSensor.i,HeatGen.u[1]) annotation(Line(points = {{58,-2},{54,-2},{54,-72},{46,-72}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end DC_DC_Conv;

  model TestDCDC
    VerySimpleDCDC dC_DC_Conv(vout = 5, inQuiescentCurrent = 0, HeatCap = 1, Gcond = 0.5, Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.ContinuousDerivative), efficiencyTable = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.8;4.5,0.8;5.0,0.8]) annotation(Placement(transformation(extent = {{-34,-8},{-14,12}})));
    Modelica.Electrical.Analog.Sources.ConstantVoltage constantVoltage(V = 5) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-94,12})));
    Modelica.Electrical.Analog.Basic.VariableResistor variableResistor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {82,-2})));
    Modelica.Blocks.Sources.SawTooth sawTooth(period = 30, amplitude = 50, offset = 1) annotation(Placement(transformation(extent = {{58,46},{78,66}})));
    Modelica.Electrical.Analog.Basic.Ground ground annotation(Placement(transformation(extent = {{-32,-56},{-12,-36}})));
    HeatSink heatSink(G_toBoard = 4, G_toEnv = 1, Cap = 4) annotation(Placement(transformation(extent = {{-76,-58},{-56,-38}})));
    Modelica.Electrical.Analog.Sources.PulseVoltage pulseVoltage(V = 5, width = 50, period = 1) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 0, origin = {-58,54})));
    Modelica.Electrical.Analog.Basic.Capacitor capacitor(C = 2.2e-005) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {58,2})));
    Modelica.Electrical.Analog.Basic.Capacitor capacitor1(C = 2.2e-011) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {38,4})));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 10) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {16,4})));
  equation
    connect(constantVoltage.p,dC_DC_Conv.p) annotation(Line(points = {{-94,22},{-62,22},{-62,6.4},{-33.8,6.4}}, color = {0,0,255}, smooth = Smooth.None));
    connect(constantVoltage.n,dC_DC_Conv.n) annotation(Line(points = {{-94,2},{-82,2},{-82,-8},{-66,-8},{-66,2},{-33.8,2}}, color = {0,0,255}, smooth = Smooth.None));
    connect(dC_DC_Conv.p1,variableResistor.p) annotation(Line(points = {{-12.7,5.7},{4,5.7},{4,28},{82,28},{82,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(variableResistor.n,dC_DC_Conv.n1) annotation(Line(points = {{82,-12},{82,-16},{2,-16},{2,0.6},{-13.2,0.6}}, color = {0,0,255}, smooth = Smooth.None));
    connect(sawTooth.y,variableResistor.R) annotation(Line(points = {{79,56},{96,56},{96,-2},{93,-2}}, color = {0,0,127}, smooth = Smooth.None));
    connect(dC_DC_Conv.n,ground.p) annotation(Line(points = {{-33.8,2},{-42,2},{-42,-30},{-22,-30},{-22,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(dC_DC_Conv.n1,ground.p) annotation(Line(points = {{-13.2,0.6},{2,0.6},{2,-36},{-22,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(dC_DC_Conv.HeatPort,heatSink.port_a) annotation(Line(points = {{-24,-7.6},{-50,-7.6},{-50,-24},{-72.40000000000001,-24},{-72.40000000000001,-47.2}}, color = {191,0,0}, smooth = Smooth.None));
    connect(pulseVoltage.n,dC_DC_Conv.n) annotation(Line(points = {{-48,54},{-48,2},{-33.8,2}}, color = {0,0,255}, smooth = Smooth.None));
    connect(capacitor.p,variableResistor.p) annotation(Line(points = {{58,12},{58,24},{82,24},{82,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(capacitor.n,dC_DC_Conv.n1) annotation(Line(points = {{58,-8},{58,-16},{2,-16},{2,0.6},{-13.2,0.6}}, color = {0,0,255}, smooth = Smooth.None));
    connect(capacitor1.n,dC_DC_Conv.n1) annotation(Line(points = {{38,-6},{38,-16},{2,-16},{2,0.6},{-13.2,0.6}}, color = {0,0,255}, smooth = Smooth.None));
    connect(capacitor1.p,variableResistor.p) annotation(Line(points = {{38,14},{38,24},{82,24},{82,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pulseVoltage.p,dC_DC_Conv.EN) annotation(Line(points = {{-68,54},{-70,54},{-70,-3.3},{-33.7,-3.3}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.p,variableResistor.p) annotation(Line(points = {{16,14},{16,28},{82,28},{82,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,dC_DC_Conv.n1) annotation(Line(points = {{16,-6},{16,-16},{2,-16},{2,0.6},{-13.2,0.6}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end TestDCDC;

  model GenericDC_DC_Conv
    parameter Real vout = 3.3 "Target Voltage Output";
    parameter Real inQuiescentCurrent = 0.06
      "Input Current with No Output Load";
    parameter Modelica.SIunits.HeatCapacity HeatCap = 1
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond = 1
      "Constant thermal conductance of material";
    parameter Real efficiencyTable[:,2] = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]
      "Efficiency Of DC DC converter vs Current";
    parameter Real heatGenTable[:,2] = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]
      "Heat Production Of DC DC converter vs Current";
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-92,18},{-72,38}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-72,-34},{-92,-14}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{88,18},{108,38}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{108,-34},{88,-14}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalCurrent signalCurrent annotation(Placement(transformation(extent = {{-58,18},{-38,38}})));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {38,4})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 0, origin = {68,18})));
    Modelica.Blocks.Sources.Constant VoltageOut(k = vout) annotation(Placement(transformation(extent = {{10,-40},{30,-20}})));
    Modelica.Blocks.Tables.CombiTable1D Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {66,52})));
    Modelica.Blocks.Math.Division division annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {24,42})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{-7,-7},{7,7}}, rotation = 180, origin = {-33,51})));
    Modelica.Blocks.Sources.Constant InputQuiescentCurrent(k = inQuiescentCurrent) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {36,82})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow surrogateHeatGen annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {8,-62})));
    Modelica.Blocks.Tables.CombiTable1D HeatGen(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {44,-62})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort annotation(Placement(transformation(extent = {{-94,-74},{-74,-54}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = HeatCap) annotation(Placement(transformation(extent = {{-70,-64},{-50,-44}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-24,-62})));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-62,4})));
    Modelica.Blocks.Math.Division division1 annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {12,8})));
    Modelica.Blocks.Math.Product product1 annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {-10,42})));
  equation
    connect(p,signalCurrent.p) annotation(Line(points = {{-82,28},{-58,28}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalCurrent.n,n) annotation(Line(points = {{-38,28},{-34,28},{-34,-24},{-82,-24}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.p,currentSensor.p) annotation(Line(points = {{38,14},{48,14},{48,18},{58,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.n,p1) annotation(Line(points = {{78,18},{90,18},{90,28},{98,28}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n1) annotation(Line(points = {{38,-6},{38,-24},{98,-24}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VoltageOut.y,signalVoltage.v) annotation(Line(points = {{31,-30},{52,-30},{52,4},{45,4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,Efficiency.u[1]) annotation(Line(points = {{68,8},{86,8},{86,52},{78,52}}, color = {0,0,127}, smooth = Smooth.None));
    connect(InputQuiescentCurrent.y,add.u2) annotation(Line(points = {{25,82},{10,82},{10,55.2},{-24.6,55.2}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,division.u1) annotation(Line(points = {{68,8},{82,8},{82,36},{36,36}}, color = {0,0,127}, smooth = Smooth.None));
    connect(Efficiency.y[1],division.u2) annotation(Line(points = {{55,52},{42,52},{42,48},{36,48}}, color = {0,0,127}, smooth = Smooth.None));
    connect(HeatGen.y[1],surrogateHeatGen.Q_flow) annotation(Line(points = {{33,-62},{18,-62}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,HeatGen.u[1]) annotation(Line(points = {{68,8},{64,8},{64,-62},{56,-62}}, color = {0,0,127}, smooth = Smooth.None));
    connect(surrogateHeatGen.port,thermalConductor.port_a) annotation(Line(points = {{-2,-62},{-14,-62}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatCapacitor.port) annotation(Line(points = {{-34,-62},{-46,-62},{-46,-64},{-60,-64}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,HeatPort) annotation(Line(points = {{-60,-64},{-84,-64}}, color = {191,0,0}, smooth = Smooth.None));
    connect(voltageSensor.p,signalCurrent.p) annotation(Line(points = {{-62,14},{-70,14},{-70,28},{-58,28}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.n,n) annotation(Line(points = {{-62,-6},{-70,-6},{-70,-24},{-82,-24}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VoltageOut.y,division1.u1) annotation(Line(points = {{31,-30},{34,-30},{34,-10},{24,-10},{24,4.4},{19.2,4.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(voltageSensor.v,division1.u2) annotation(Line(points = {{-72,4},{-72,4},{-76,4},{-76,4},{-76,4},{-76,-16},{-36,-16},{-36,14},{-18,14},{-18,18},{24,18},{24,11.6},{19.2,11.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product1.y,add.u1) annotation(Line(points = {{-16.6,42},{-18,42},{-18,46.8},{-24.6,46.8}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.y,product1.u2) annotation(Line(points = {{13,42},{6,42},{6,45.6},{-2.8,45.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division1.y,product1.u1) annotation(Line(points = {{5.4,8},{4,8},{4,10},{2,10},{2,38.4},{-2.8,38.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.y,signalCurrent.i) annotation(Line(points = {{-40.7,51},{-48,51},{-48,35}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end GenericDC_DC_Conv;

  model GenericDC_DC_Conv_EN
    parameter Real vout = 3.3 "Target Voltage Output";
    parameter Real inQuiescentCurrent = 0.06
      "Input Current with No Output Load";
    parameter Modelica.SIunits.HeatCapacity HeatCap = 1
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond = 1
      "Constant thermal conductance of material";
    parameter Real efficiencyTable[:,2] = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]
      "Efficiency Of DC DC converter vs Current";
    parameter Real heatGenTable[:,2] = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]
      "Heat Production Of DC DC converter vs Current";
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-82,28},{-62,48}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-62,-24},{-82,-4}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{104,28},{124,48}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{118,-24},{98,-4}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalCurrent signalCurrent annotation(Placement(transformation(extent = {{-48,28},{-28,48}})));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {48,14})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 0, origin = {67,25})));
    Modelica.Blocks.Sources.Constant VoltageOut(k = vout) annotation(Placement(transformation(extent = {{8,-20},{18,-10}})));
    Modelica.Blocks.Tables.CombiTable1D Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {72,58})));
    Modelica.Blocks.Math.Division division annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {30,48})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {-31,61})));
    Modelica.Blocks.Sources.Constant InputQuiescentCurrent(k = inQuiescentCurrent) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {41,87})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow surrogateHeatGen annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {18,-52})));
    Modelica.Blocks.Tables.CombiTable1D HeatGen(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {54,-52})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort annotation(Placement(transformation(extent = {{-84,-64},{-64,-44}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = HeatCap) annotation(Placement(transformation(extent = {{-60,-54},{-40,-34}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-14,-52})));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-52,14})));
    Modelica.Blocks.Math.Division division1 annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {22,18})));
    Modelica.Blocks.Math.Product product1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {4,50})));
    Modelica.Electrical.Analog.Interfaces.PositivePin EN
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-84,76},{-64,96}}, rotation = 0)));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = -90, origin = {-82,70})));
    Modelica.Blocks.Math.Sign sign1 annotation(Placement(transformation(extent = {{-3,-3},{3,3}}, rotation = 180, origin = {-93,69})));
    Modelica.Blocks.Math.Product product2 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {-16,48})));
    Modelica.Blocks.Math.Product product3 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 0, origin = {46,-22})));
    Modelica.Electrical.Analog.Basic.Resistor Supply_Res(R = 0.01) annotation(Placement(transformation(extent = {{92,32},{102,42}})));
  equation
    connect(p,signalCurrent.p) annotation(Line(points = {{-72,38},{-48,38}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalCurrent.n,n) annotation(Line(points = {{-28,38},{-24,38},{-24,-14},{-72,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.p,currentSensor.p) annotation(Line(points = {{48,24},{58,24},{58,25},{62,25}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n1) annotation(Line(points = {{48,4},{48,-14},{108,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,Efficiency.u[1]) annotation(Line(points = {{67,20},{96,20},{96,58},{79.2,58}}, color = {0,0,127}, smooth = Smooth.None));
    connect(InputQuiescentCurrent.y,add.u2) annotation(Line(points = {{35.5,87},{20,87},{20,64},{-25,64}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,division.u1) annotation(Line(points = {{67,20},{80,20},{80,44.4},{37.2,44.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(Efficiency.y[1],division.u2) annotation(Line(points = {{65.40000000000001,58},{54,58},{54,51.6},{37.2,51.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(HeatGen.y[1],surrogateHeatGen.Q_flow) annotation(Line(points = {{43,-52},{28,-52}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,HeatGen.u[1]) annotation(Line(points = {{67,20},{74,20},{74,-52},{66,-52}}, color = {0,0,127}, smooth = Smooth.None));
    connect(surrogateHeatGen.port,thermalConductor.port_a) annotation(Line(points = {{8,-52},{-4,-52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatCapacitor.port) annotation(Line(points = {{-24,-52},{-36,-52},{-36,-54},{-50,-54}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,HeatPort) annotation(Line(points = {{-50,-54},{-74,-54}}, color = {191,0,0}, smooth = Smooth.None));
    connect(voltageSensor.p,signalCurrent.p) annotation(Line(points = {{-52,24},{-60,24},{-60,38},{-48,38}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.n,n) annotation(Line(points = {{-52,4},{-60,4},{-60,-14},{-72,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(VoltageOut.y,division1.u1) annotation(Line(points = {{18.5,-15},{34,-15},{34,14.4},{29.2,14.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(voltageSensor.v,division1.u2) annotation(Line(points = {{-62,14},{-66,14},{-66,-6},{-26,-6},{-26,24},{-8,24},{-8,28},{34,28},{34,21.6},{29.2,21.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.y,product1.u2) annotation(Line(points = {{23.4,48},{14,48},{14,52.4},{8.800000000000001,52.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division1.y,product1.u1) annotation(Line(points = {{15.4,18},{14,18},{14,20},{12,20},{12,47.6},{8.800000000000001,47.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.y,signalCurrent.i) annotation(Line(points = {{-36.5,61},{-38,61},{-38,45}}, color = {0,0,127}, smooth = Smooth.None));
    connect(EN,EN) annotation(Line(points = {{-74,86},{-74,86}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EN,voltageSensor1.p) annotation(Line(points = {{-74,86},{-74,74},{-82,74}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.n,n) annotation(Line(points = {{-82,66},{-82,16},{-72,16},{-72,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.v,sign1.u) annotation(Line(points = {{-86,70},{-88,70},{-88,69},{-89.40000000000001,69}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product1.y,product2.u2) annotation(Line(points = {{-0.4,50},{-4,50},{-4,50.4},{-11.2,50.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product2.y,add.u1) annotation(Line(points = {{-20.4,48},{-20,48},{-20,58},{-25,58}}, color = {0,0,127}, smooth = Smooth.None));
    connect(sign1.y,product2.u1) annotation(Line(points = {{-96.3,69},{-98,69},{-98,76},{-4,76},{-4,45.6},{-11.2,45.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(VoltageOut.y,product3.u1) annotation(Line(points = {{18.5,-15},{30,-15},{30,-19.6},{41.2,-19.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product3.y,signalVoltage.v) annotation(Line(points = {{50.4,-22},{62,-22},{62,14},{55,14}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product2.u1,product3.u2) annotation(Line(points = {{-11.2,45.6},{-2,45.6},{-2,-4},{-10,-4},{-10,-36},{30,-36},{30,-24.4},{41.2,-24.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.n,Supply_Res.p) annotation(Line(points = {{72,25},{82,25},{82,37},{92,37}}, color = {0,0,255}, smooth = Smooth.None));
    connect(Supply_Res.n,p1) annotation(Line(points = {{102,37},{108,37},{108,38},{114,38}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end GenericDC_DC_Conv_EN;

  model TestFET
    Modelica.Electrical.Analog.Sources.SawToothVoltage sawToothVoltage(V = 5, period = 3) annotation(Placement(transformation(extent = {{-10,-11},{10,11}}, rotation = -90, origin = {-42,25})));
    Modelica.Electrical.Analog.Sources.ConstantVoltage constantVoltage(V = 10) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-82,58})));
    Modelica.Electrical.Analog.Basic.Ground ground annotation(Placement(transformation(extent = {{-46,-42},{-26,-22}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 100) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {20,70})));
    Modelica.Electrical.Analog.Semiconductors.NMOS nMOS(W = 0.0001, Beta = 0.2) annotation(Placement(transformation(extent = {{6,20},{26,40}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor1(R = 100) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {50,70})));
    PFET_Simple pFET_Simple(Cap = 1, Gcond = 1) annotation(Placement(transformation(extent = {{42,18},{62,38}})));
  equation
    connect(constantVoltage.n,ground.p) annotation(Line(points = {{-82,48},{-82,-22},{-36,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(sawToothVoltage.n,ground.p) annotation(Line(points = {{-42,15},{-42,-22},{-36,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(constantVoltage.p,resistor.p) annotation(Line(points = {{-82,68},{-82,88},{20,88},{20,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,nMOS.D) annotation(Line(points = {{20,60},{24,60},{24,35},{26,35}}, color = {0,0,255}, smooth = Smooth.None));
    connect(sawToothVoltage.p,nMOS.G) annotation(Line(points = {{-42,35},{-18,35},{-18,25},{6,25}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nMOS.S,ground.p) annotation(Line(points = {{26,25},{26,-22},{-36,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(constantVoltage.p,resistor1.p) annotation(Line(points = {{-82,68},{-82,88},{50,88},{50,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nMOS.B,ground.p) annotation(Line(points = {{26,30},{26,-22},{-36,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor1.n,pFET_Simple.S) annotation(Line(points = {{50,60},{46,60},{46,42},{45.6,42},{45.6,36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.D,ground.p) annotation(Line(points = {{45.4,24},{44,24},{44,-22},{-36,-22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.G,nMOS.G) annotation(Line(points = {{45.6,31.6},{34,31.6},{34,18},{6,18},{6,25}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end TestFET;

  model PFET_Simple "Simplified FET Mode"
    parameter Modelica.SIunits.HeatCapacity Cap
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond
      "Constant thermal conductance of material";
    Modelica.Electrical.Analog.Interfaces.PositivePin G "positive pin" annotation(Placement(transformation(extent = {{-74,26},{-54,46}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin D
      "Negative pin of the input port"                                                   annotation(Placement(transformation(extent = {{-76,-50},{-56,-30}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin S "positive pin" annotation(Placement(transformation(extent = {{-74,70},{-54,90}}, rotation = 0)));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-8,26})));
    Modelica.Electrical.Analog.Basic.VariableResistor variableResistor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {48,46})));
    Modelica.Blocks.Tables.CombiTable1D ResistanceTransferFunction(smoothness = Modelica.Blocks.Types.Smoothness.ContinuousDerivative, table = [0,0.01;0.6,0.01;0.8,0.1;1,1;1.2,4;2,100;3,10000]) annotation(Placement(transformation(extent = {{4,-18},{24,2}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin B "positive pin" annotation(Placement(transformation(extent = {{72,-40},{92,-20}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 10000) annotation(Placement(transformation(extent = {{34,-74},{54,-54}})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-18,70},{2,90}})));
    Modelica.Blocks.Math.Product product1 annotation(Placement(transformation(extent = {{76,52},{88,64}})));
    Modelica.Blocks.Math.Product product2 annotation(Placement(transformation(extent = {{4,54},{14,64}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = Cap) annotation(Placement(transformation(extent = {{-18,-84},{2,-64}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{18,-104},{38,-84}})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow prescribedHeatFlow annotation(Placement(transformation(extent = {{-50,-106},{-30,-86}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a heatPort annotation(Placement(transformation(extent = {{64,-104},{84,-84}})));
  equation
    connect(S,S) annotation(Line(points = {{-64,80},{-64,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(G,voltageSensor.p) annotation(Line(points = {{-64,36},{-8,36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.n,D) annotation(Line(points = {{-8,16},{-66,16},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.v,ResistanceTransferFunction.u[1]) annotation(Line(points = {{-18,26},{-34,26},{-34,-8},{2,-8}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ResistanceTransferFunction.y[1],variableResistor.R) annotation(Line(points = {{25,-8},{68,-8},{68,46},{59,46}}, color = {0,0,127}, smooth = Smooth.None));
    connect(variableResistor.n,D) annotation(Line(points = {{48,36},{48,-40},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,B) annotation(Line(points = {{54,-64},{66,-64},{66,-30},{82,-30}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.p,D) annotation(Line(points = {{34,-64},{32,-64},{32,-40},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(S,currentSensor.p) annotation(Line(points = {{-64,80},{-18,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.n,variableResistor.p) annotation(Line(points = {{2,80},{48,80},{48,56}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,product2.u1) annotation(Line(points = {{-8,70},{-4,70},{-4,62},{3,62}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,product2.u2) annotation(Line(points = {{-8,70},{-8,56},{3,56}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ResistanceTransferFunction.y[1],product1.u2) annotation(Line(points = {{25,-8},{50,-8},{50,-6},{74.8,-6},{74.8,54.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product2.y,product1.u1) annotation(Line(points = {{14.5,59},{28,59},{28,62},{52,62},{52,61.6},{74.8,61.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(prescribedHeatFlow.port,heatCapacitor.port) annotation(Line(points = {{-30,-96},{-8,-96},{-8,-84}}, color = {191,0,0}, smooth = Smooth.None));
    connect(prescribedHeatFlow.port,thermalConductor.port_a) annotation(Line(points = {{-30,-96},{12,-96},{12,-94},{18,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatPort) annotation(Line(points = {{38,-94},{74,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatPort,heatPort) annotation(Line(points = {{74,-94},{74,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(product1.y,prescribedHeatFlow.Q_flow) annotation(Line(points = {{88.59999999999999,58},{92,58},{92,-50},{-54,-50},{-54,-96},{-50,-96}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end PFET_Simple;

  model NFET_Simple "Simplified FET Mode"
    parameter Modelica.SIunits.HeatCapacity Cap
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond
      "Constant thermal conductance of material";
    Modelica.Electrical.Analog.Interfaces.PositivePin G "positive pin" annotation(Placement(transformation(extent = {{-74,26},{-54,46}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin S
      "Negative pin of the input port"                                                   annotation(Placement(transformation(extent = {{-76,-50},{-56,-30}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin D "positive pin" annotation(Placement(transformation(extent = {{-74,70},{-54,90}}, rotation = 0)));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-8,26})));
    Modelica.Electrical.Analog.Basic.VariableResistor variableResistor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {48,46})));
    Modelica.Blocks.Tables.CombiTable1D ResistanceTransferFunction(smoothness = Modelica.Blocks.Types.Smoothness.ContinuousDerivative, table = [0,1000000;0.6,100000;0.8,1;1,0.01;1.2,0.0001;2,1e-005;3,1e-005]) annotation(Placement(transformation(extent = {{4,-18},{24,2}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin B "positive pin" annotation(Placement(transformation(extent = {{72,-40},{92,-20}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 10000) annotation(Placement(transformation(extent = {{34,-74},{54,-54}})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-18,70},{2,90}})));
    Modelica.Blocks.Math.Product product1 annotation(Placement(transformation(extent = {{76,52},{88,64}})));
    Modelica.Blocks.Math.Product product2 annotation(Placement(transformation(extent = {{4,54},{14,64}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = Cap) annotation(Placement(transformation(extent = {{-18,-84},{2,-64}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{18,-104},{38,-84}})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow prescribedHeatFlow annotation(Placement(transformation(extent = {{-50,-106},{-30,-86}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a heatPort annotation(Placement(transformation(extent = {{64,-104},{84,-84}})));
  equation
    connect(D,D) annotation(Line(points = {{-64,80},{-64,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(G,voltageSensor.p) annotation(Line(points = {{-64,36},{-8,36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.n,S) annotation(Line(points = {{-8,16},{-66,16},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor.v,ResistanceTransferFunction.u[1]) annotation(Line(points = {{-18,26},{-34,26},{-34,-8},{2,-8}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ResistanceTransferFunction.y[1],variableResistor.R) annotation(Line(points = {{25,-8},{68,-8},{68,46},{59,46}}, color = {0,0,127}, smooth = Smooth.None));
    connect(variableResistor.n,S) annotation(Line(points = {{48,36},{48,-40},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,B) annotation(Line(points = {{54,-64},{66,-64},{66,-30},{82,-30}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.p,S) annotation(Line(points = {{34,-64},{32,-64},{32,-40},{-66,-40}}, color = {0,0,255}, smooth = Smooth.None));
    connect(D,currentSensor.p) annotation(Line(points = {{-64,80},{-18,80}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.n,variableResistor.p) annotation(Line(points = {{2,80},{48,80},{48,56}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,product2.u1) annotation(Line(points = {{-8,70},{-4,70},{-4,62},{3,62}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,product2.u2) annotation(Line(points = {{-8,70},{-8,56},{3,56}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ResistanceTransferFunction.y[1],product1.u2) annotation(Line(points = {{25,-8},{50,-8},{50,-6},{74.8,-6},{74.8,54.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product2.y,product1.u1) annotation(Line(points = {{14.5,59},{28,59},{28,62},{52,62},{52,61.6},{74.8,61.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(prescribedHeatFlow.port,heatCapacitor.port) annotation(Line(points = {{-30,-96},{-8,-96},{-8,-84}}, color = {191,0,0}, smooth = Smooth.None));
    connect(prescribedHeatFlow.port,thermalConductor.port_a) annotation(Line(points = {{-30,-96},{12,-96},{12,-94},{18,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatPort) annotation(Line(points = {{38,-94},{74,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatPort,heatPort) annotation(Line(points = {{74,-94},{74,-94}}, color = {191,0,0}, smooth = Smooth.None));
    connect(product1.y,prescribedHeatFlow.Q_flow) annotation(Line(points = {{88.59999999999999,58},{92,58},{92,-50},{-54,-50},{-54,-96},{-50,-96}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end NFET_Simple;

  model VerySimpleDCDC
    parameter Real vout = 3.3 "Target Voltage Output";
    parameter Real inQuiescentCurrent = 0.06
      "Input Current with No Output Load";
    parameter Modelica.SIunits.HeatCapacity HeatCap = 1
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond = 1
      "Constant thermal conductance of material";
    parameter Real efficiencyTable[:,2] = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]
      "Efficiency Of DC DC converter vs Current";
    parameter Real heatGenTable[:,2] = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]
      "Heat Production Of DC DC converter vs Current";
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-106,36},{-90,52}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-92,-6},{-104,6}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{108,32},{118,42}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{118,-24},{98,-4}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {48,14})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 0, origin = {67,37})));
    Modelica.Blocks.Sources.Constant VoltageOut(k = vout) annotation(Placement(transformation(extent = {{8,-20},{18,-10}})));
    Modelica.Blocks.Tables.CombiTable1D Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {72,72})));
    Modelica.Blocks.Sources.Constant InputQuiescentCurrent(k = inQuiescentCurrent) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {41,87})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow surrogateHeatGen annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {18,-52})));
    Modelica.Blocks.Tables.CombiTable1D HeatGen(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {50,-52})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort annotation(Placement(transformation(extent = {{-10,-106},{10,-86}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = HeatCap) annotation(Placement(transformation(extent = {{-60,-54},{-40,-34}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-14,-52})));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-54,14})));
    Modelica.Electrical.Analog.Interfaces.PositivePin EN
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-104,-60},{-90,-46}}, rotation = 0)));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 90, origin = {-70,-32})));
    Modelica.Blocks.Math.Sign sign1 annotation(Placement(transformation(extent = {{-3,-3},{3,3}}, rotation = 0, origin = {15,-33})));
    Modelica.Blocks.Math.Product product3 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 0, origin = {46,-22})));
    Modelica.Electrical.Analog.Basic.Resistor Supply_Res(R = 0.01) annotation(Placement(transformation(extent = {{92,32},{102,42}})));
    Modelica.Electrical.Analog.Basic.VariableResistor variableResistor annotation(Placement(transformation(extent = {{-8,-8},{8,8}}, rotation = -90, origin = {-30,14})));
    Modelica.Blocks.Math.Product ViSquard annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 0, origin = {-26,52})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {16,82})));
    Modelica.Blocks.Math.Division ViSquard1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {46,70})));
    Modelica.Blocks.Math.Division division annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {-1,79})));
    Modelica.Blocks.Math.Add add1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {-10,34})));
    Modelica.Blocks.Sources.Constant MinResistance(k = 0.05) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {15,33})));
    Modelica.Blocks.Continuous.LowpassButterworth lowpassButterworth(f = 10) annotation(Placement(transformation(extent = {{-74,62},{-66,70}})));
  equation
    connect(signalVoltage.p,currentSensor.p) annotation(Line(points = {{48,24},{48,37},{62,37}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n1) annotation(Line(points = {{48,4},{48,-14},{108,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,Efficiency.u[1]) annotation(Line(points = {{67,32},{86,32},{86,72},{79.2,72}}, color = {0,0,127}, smooth = Smooth.None));
    connect(HeatGen.y[1],surrogateHeatGen.Q_flow) annotation(Line(points = {{39,-52},{28,-52}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,HeatGen.u[1]) annotation(Line(points = {{67,32},{68,32},{68,-52},{62,-52}}, color = {0,0,127}, smooth = Smooth.None));
    connect(surrogateHeatGen.port,thermalConductor.port_a) annotation(Line(points = {{8,-52},{-4,-52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatCapacitor.port) annotation(Line(points = {{-24,-52},{-36,-52},{-36,-54},{-50,-54}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,HeatPort) annotation(Line(points = {{-50,-54},{-62,-54},{-62,-96},{0,-96}}, color = {191,0,0}, smooth = Smooth.None));
    connect(voltageSensor.n,n) annotation(Line(points = {{-54,4},{-74,4},{-74,0},{-98,0}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EN,voltageSensor1.p) annotation(Line(points = {{-97,-53},{-97,-36},{-70,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.n,n) annotation(Line(points = {{-70,-28},{-70,0},{-98,0}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.v,sign1.u) annotation(Line(points = {{-66,-32},{-66,-33},{11.4,-33}}, color = {0,0,127}, smooth = Smooth.None));
    connect(VoltageOut.y,product3.u1) annotation(Line(points = {{18.5,-15},{30,-15},{30,-19.6},{41.2,-19.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product3.y,signalVoltage.v) annotation(Line(points = {{50.4,-22},{62,-22},{62,14},{55,14}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.n,Supply_Res.p) annotation(Line(points = {{72,37},{92,37}}, color = {0,0,255}, smooth = Smooth.None));
    connect(Supply_Res.n,p1) annotation(Line(points = {{102,37},{113,37}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p,variableResistor.p) annotation(Line(points = {{-98,44},{-30,44},{-30,22}}, color = {0,0,255}, smooth = Smooth.None));
    connect(variableResistor.n,n) annotation(Line(points = {{-30,6},{-30,0},{-98,0}}, color = {0,0,255}, smooth = Smooth.None));
    connect(sign1.y,product3.u2) annotation(Line(points = {{18.3,-33},{28,-33},{28,-34},{41.2,-34},{41.2,-24.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ViSquard.u1,ViSquard.u2) annotation(Line(points = {{-30.8,54.4},{-40,54.4},{-40,56},{-54,56},{-54,50},{-30.8,50},{-30.8,49.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(Efficiency.y[1],ViSquard1.u2) annotation(Line(points = {{65.40000000000001,72},{58,72},{58,72.40000000000001},{50.8,72.40000000000001}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ViSquard1.u1,Efficiency.u[1]) annotation(Line(points = {{50.8,67.59999999999999},{58,67.59999999999999},{58,54},{86,54},{86,72},{79.2,72}}, color = {0,0,127}, smooth = Smooth.None));
    connect(InputQuiescentCurrent.y,add.u2) annotation(Line(points = {{35.5,87},{30,87},{30,84.40000000000001},{20.8,84.40000000000001}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.u1,ViSquard1.y) annotation(Line(points = {{20.8,79.59999999999999},{28,79.59999999999999},{28,70},{41.6,70}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.u2,add.y) annotation(Line(points = {{5,82},{11.6,82}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ViSquard.y,division.u1) annotation(Line(points = {{-21.6,52},{8,52},{8,76},{5,76}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.y,add1.u2) annotation(Line(points = {{-6.5,79},{-12,79},{-12,44},{0,44},{0,36.4},{-5.2,36.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(MinResistance.y,add1.u1) annotation(Line(points = {{9.5,33},{3.75,33},{3.75,31.6},{-5.2,31.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add1.y,variableResistor.R) annotation(Line(points = {{-14.4,34},{-21.2,34},{-21.2,14}}, color = {0,0,127}, smooth = Smooth.None));
    connect(lowpassButterworth.y,ViSquard.u2) annotation(Line(points = {{-65.59999999999999,66},{-58,66},{-58,54},{-54,54},{-54,50},{-30.8,50},{-30.8,49.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(voltageSensor.v,lowpassButterworth.u) annotation(Line(points = {{-64,14},{-82,14},{-82,66},{-74.8,66}}, color = {0,0,127}, smooth = Smooth.None));
    connect(voltageSensor.p,variableResistor.p) annotation(Line(points = {{-54,24},{-56,24},{-56,44},{-30,44},{-30,22}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end VerySimpleDCDC;

  model Ara_Interface
    Modelica.Electrical.Analog.Sources.ConstantVoltage constantVoltage(V = 5) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {26,40})));
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{66,74},{86,94}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{88,4},{68,24}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = 0.01) annotation(Placement(transformation(extent = {{40,74},{60,94}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = 5) annotation(Placement(transformation(extent = {{-18,64},{2,84}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = 1) annotation(Placement(transformation(extent = {{-22,18},{-2,38}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor1(G = 1) annotation(Placement(transformation(extent = {{-54,42},{-34,62}})));
    Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T = 293.15) annotation(Placement(transformation(extent = {{-54,16},{-34,36}})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a annotation(Placement(transformation(extent = {{-86,42},{-66,62}})));
  equation
    connect(constantVoltage.p,resistor.p) annotation(Line(points = {{26,50},{26,84},{40,84}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor.n,p) annotation(Line(points = {{60,84},{76,84}}, color = {0,0,255}, smooth = Smooth.None));
    connect(constantVoltage.n,n) annotation(Line(points = {{26,30},{26,14},{78,14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(port_a,thermalConductor1.port_a) annotation(Line(points = {{-76,52},{-54,52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,thermalConductor1.port_b) annotation(Line(points = {{-8,64},{-8,52},{-34,52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(fixedTemperature.port,thermalConductor.port_a) annotation(Line(points = {{-34,26},{-28,26},{-28,28},{-22,28}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,thermalConductor1.port_b) annotation(Line(points = {{-2,28},{4,28},{4,52},{-34,52}}, color = {191,0,0}, smooth = Smooth.None));
    connect(n,n) annotation(Line(points = {{78,14},{78,14}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-80,0},{80,100}}), graphics), Icon(coordinateSystem(extent = {{-80,0},{80,100}})));
  end Ara_Interface;

  model TestEPMCkt
    Modelica.Electrical.Analog.Basic.Resistor resistor1(R = 278) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = -90, origin = {24,38})));
    Modelica.Electrical.Analog.Basic.Ground ground annotation(Placement(transformation(extent = {{-8,-56},{12,-36}})));
    Ara_Interface ara_Interface annotation(Placement(transformation(extent = {{-92,2},{-76,12}})));
    VerySimpleDCDC verySimpleDCDC(vout = 28, HeatCap = 1, Gcond = 1) annotation(Placement(transformation(extent = {{-32,-2},{-12,18}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor2(R = 100) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = -90, origin = {24,12})));
    NFET_Simple nFET_Simple(Cap = 11, Gcond = 1) annotation(Placement(transformation(extent = {{38,-32},{58,-12}})));
    Modelica.Electrical.Analog.Sources.PulseVoltage pulseVoltage(V = 5, width = 66, period = 2) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-82,-26})));
    NFET_Simple nFET_Simple1(Cap = 11, Gcond = 1) annotation(Placement(transformation(extent = {{72,-32},{92,-12}})));
    Modelica.Electrical.Analog.Basic.Resistor resistor3(R = 1) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = -90, origin = {52,12})));
    Modelica.Electrical.Analog.Sources.PulseVoltage pulseVoltage1(V = 5, width = 33, period = 1) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {-102,-26})));
    PFET_Simple pFET_Simple(Cap = 11, Gcond = 1) annotation(Placement(transformation(extent = {{54,36},{74,56}})));
  equation
    connect(ara_Interface.n,ground.p) annotation(Line(points = {{-76.2,3.4},{-62,3.4},{-62,-36},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(verySimpleDCDC.n1,ground.p) annotation(Line(points = {{-11.2,6.6},{-2,6.6},{-2,-36},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(verySimpleDCDC.p1,resistor1.p) annotation(Line(points = {{-10.7,11.7},{2.65,11.7},{2.65,44},{24,44}}, color = {0,0,255}, smooth = Smooth.None));
    connect(ara_Interface.p,verySimpleDCDC.p) annotation(Line(points = {{-76.40000000000001,10.4},{-63.2,10.4},{-63.2,12.4},{-31.8,12.4}}, color = {0,0,255}, smooth = Smooth.None));
    connect(ara_Interface.n,verySimpleDCDC.n) annotation(Line(points = {{-76.2,3.4},{-54.1,3.4},{-54.1,8},{-31.8,8}}, color = {0,0,255}, smooth = Smooth.None));
    connect(ara_Interface.p,verySimpleDCDC.EN) annotation(Line(points = {{-76.40000000000001,10.4},{-42,10.4},{-42,2.7},{-31.7,2.7}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor1.n,resistor2.p) annotation(Line(points = {{24,32},{24,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor2.n,nFET_Simple.D) annotation(Line(points = {{24,6},{26,6},{26,-14},{41.6,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nFET_Simple.S,ground.p) annotation(Line(points = {{41.4,-26},{26,-26},{26,-30},{2,-30},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pulseVoltage.n,ground.p) annotation(Line(points = {{-82,-36},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pulseVoltage.p,nFET_Simple.G) annotation(Line(points = {{-82,-16},{14,-16},{14,-18.4},{41.6,-18.4}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nFET_Simple.B,ground.p) annotation(Line(points = {{56.2,-25},{68,-25},{68,-38},{32,-38},{32,-26},{26,-26},{26,-30},{2,-30},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nFET_Simple1.B,ground.p) annotation(Line(points = {{90.2,-25},{96,-25},{96,-38},{32,-38},{32,-26},{26,-26},{26,-30},{2,-30},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(nFET_Simple1.S,ground.p) annotation(Line(points = {{75.40000000000001,-26},{66,-26},{68,-25},{68,-38},{32,-38},{32,-26},{26,-26},{26,-30},{2,-30},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(resistor3.n,nFET_Simple1.D) annotation(Line(points = {{52,6},{52,-2},{75.59999999999999,-2},{75.59999999999999,-14}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pulseVoltage1.n,ground.p) annotation(Line(points = {{-102,-36},{2,-36}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.D,resistor3.p) annotation(Line(points = {{57.4,42},{52,42},{52,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.G,resistor2.p) annotation(Line(points = {{57.6,49.6},{44,49.6},{44,26},{24,26},{24,18}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.S,resistor1.p) annotation(Line(points = {{57.6,54},{2,54},{2,42},{2.65,44},{24,44}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pFET_Simple.B,pFET_Simple.S) annotation(Line(points = {{72.2,43},{82,43},{82,58},{57.6,58},{57.6,54}}, color = {0,0,255}, smooth = Smooth.None));
    connect(pulseVoltage1.p,nFET_Simple1.G) annotation(Line(points = {{-102,-16},{-102,-8},{66,-8},{66,-18.4},{75.59999999999999,-18.4}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end TestEPMCkt;

  model StaticDCDC_Conv
    parameter Real vout = 3.3 "Target Voltage Output";
    parameter Real inQuiescentCurrent = 0.06
      "Input Current with No Output Load";
    parameter Modelica.SIunits.HeatCapacity HeatCap = 1
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond = 1
      "Constant thermal conductance of material";
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-96,46},{-80,62}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-82,4},{-94,16}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{118,42},{128,52}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{128,-14},{108,6}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {58,24})));
    Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 0, origin = {77,47})));
    Modelica.Blocks.Sources.Constant VoltageOut(k = vout) annotation(Placement(transformation(extent = {{18,-10},{28,0}})));
    Modelica.Blocks.Tables.CombiTable1D Efficiency(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.4;0.1,0.5;0.2,0.8;0.3,0.9;0.5,0.95;1,0.93;2.0,0.92;3.5,0.88;4.0,0.1;4.5,0.1;5.0,0.1]) annotation(Placement(transformation(extent = {{-6,-6},{6,6}}, rotation = 180, origin = {82,82})));
    Modelica.Blocks.Sources.Constant InputQuiescentCurrent(k = inQuiescentCurrent) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {51,97})));
    Modelica.Thermal.HeatTransfer.Sources.PrescribedHeatFlow surrogateHeatGen annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {28,-42})));
    Modelica.Blocks.Tables.CombiTable1D HeatGen(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0,0.02;0.25,0.1;0.5,0.2;1.0,0.3;1.5,0.5;2,0.75;2.5,1.25;3.0,1.75;3.5,2.4;4.5,4;5.0,8]) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {60,-42})));
    Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort annotation(Placement(transformation(extent = {{0,-96},{20,-76}})));
    Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor(C = HeatCap) annotation(Placement(transformation(extent = {{-50,-44},{-30,-24}})));
    Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor(G = Gcond) annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = 180, origin = {-4,-42})));
    Modelica.Electrical.Analog.Interfaces.PositivePin EN
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{-94,-50},{-80,-36}}, rotation = 0)));
    Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 90, origin = {-60,-22})));
    Modelica.Blocks.Math.Sign sign1 annotation(Placement(transformation(extent = {{-3,-3},{3,3}}, rotation = 0, origin = {25,-23})));
    Modelica.Blocks.Math.Product product3 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 0, origin = {56,-12})));
    Modelica.Electrical.Analog.Basic.Resistor Supply_Res(R = 0.01) annotation(Placement(transformation(extent = {{102,42},{112,52}})));
    Modelica.Electrical.Analog.Basic.VariableResistor variableResistor annotation(Placement(transformation(extent = {{-8,-8},{8,8}}, rotation = -90, origin = {-20,24})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {26,92})));
    Modelica.Blocks.Math.Division ViSquard1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {56,80})));
    Modelica.Blocks.Math.Division division annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {9,89})));
    Modelica.Blocks.Math.Add add1 annotation(Placement(transformation(extent = {{-4,-4},{4,4}}, rotation = 180, origin = {0,44})));
    Modelica.Blocks.Sources.Constant MinResistance(k = 0.05) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {25,43})));
    Modelica.Blocks.Sources.Constant MinResistance1(k = 5) annotation(Placement(transformation(extent = {{-5,-5},{5,5}}, rotation = 180, origin = {31,71})));
  equation
    connect(signalVoltage.p,currentSensor.p) annotation(Line(points = {{58,34},{58,47},{72,47}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n1) annotation(Line(points = {{58,14},{58,-4},{118,-4}}, color = {0,0,255}, smooth = Smooth.None));
    connect(currentSensor.i,Efficiency.u[1]) annotation(Line(points = {{77,42},{96,42},{96,82},{89.2,82}}, color = {0,0,127}, smooth = Smooth.None));
    connect(HeatGen.y[1],surrogateHeatGen.Q_flow) annotation(Line(points = {{49,-42},{38,-42}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.i,HeatGen.u[1]) annotation(Line(points = {{77,42},{78,42},{78,-42},{72,-42}}, color = {0,0,127}, smooth = Smooth.None));
    connect(surrogateHeatGen.port,thermalConductor.port_a) annotation(Line(points = {{18,-42},{6,-42}}, color = {191,0,0}, smooth = Smooth.None));
    connect(thermalConductor.port_b,heatCapacitor.port) annotation(Line(points = {{-14,-42},{-26,-42},{-26,-44},{-40,-44}}, color = {191,0,0}, smooth = Smooth.None));
    connect(heatCapacitor.port,HeatPort) annotation(Line(points = {{-40,-44},{-52,-44},{-52,-86},{10,-86}}, color = {191,0,0}, smooth = Smooth.None));
    connect(EN,voltageSensor1.p) annotation(Line(points = {{-87,-43},{-87,-26},{-60,-26}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.n,n) annotation(Line(points = {{-60,-18},{-60,10},{-88,10}}, color = {0,0,255}, smooth = Smooth.None));
    connect(voltageSensor1.v,sign1.u) annotation(Line(points = {{-56,-22},{-56,-23},{21.4,-23}}, color = {0,0,127}, smooth = Smooth.None));
    connect(VoltageOut.y,product3.u1) annotation(Line(points = {{28.5,-5},{40,-5},{40,-9.6},{51.2,-9.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(product3.y,signalVoltage.v) annotation(Line(points = {{60.4,-12},{72,-12},{72,24},{65,24}}, color = {0,0,127}, smooth = Smooth.None));
    connect(currentSensor.n,Supply_Res.p) annotation(Line(points = {{82,47},{102,47}}, color = {0,0,255}, smooth = Smooth.None));
    connect(Supply_Res.n,p1) annotation(Line(points = {{112,47},{123,47}}, color = {0,0,255}, smooth = Smooth.None));
    connect(p,variableResistor.p) annotation(Line(points = {{-88,54},{-20,54},{-20,32}}, color = {0,0,255}, smooth = Smooth.None));
    connect(variableResistor.n,n) annotation(Line(points = {{-20,16},{-20,10},{-88,10}}, color = {0,0,255}, smooth = Smooth.None));
    connect(sign1.y,product3.u2) annotation(Line(points = {{28.3,-23},{38,-23},{38,-24},{51.2,-24},{51.2,-14.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(Efficiency.y[1],ViSquard1.u2) annotation(Line(points = {{75.40000000000001,82},{68,82},{68,82.40000000000001},{60.8,82.40000000000001}}, color = {0,0,127}, smooth = Smooth.None));
    connect(ViSquard1.u1,Efficiency.u[1]) annotation(Line(points = {{60.8,77.59999999999999},{68,77.59999999999999},{68,64},{96,64},{96,82},{89.2,82}}, color = {0,0,127}, smooth = Smooth.None));
    connect(InputQuiescentCurrent.y,add.u2) annotation(Line(points = {{45.5,97},{40,97},{40,94.40000000000001},{30.8,94.40000000000001}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.u1,ViSquard1.y) annotation(Line(points = {{30.8,89.59999999999999},{38,89.59999999999999},{38,80},{51.6,80}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.u2,add.y) annotation(Line(points = {{15,92},{21.6,92}}, color = {0,0,127}, smooth = Smooth.None));
    connect(division.y,add1.u2) annotation(Line(points = {{3.5,89},{-2,89},{-2,54},{10,54},{10,46.4},{4.8,46.4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(MinResistance.y,add1.u1) annotation(Line(points = {{19.5,43},{13.75,43},{13.75,41.6},{4.8,41.6}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add1.y,variableResistor.R) annotation(Line(points = {{-4.4,44},{-11.2,44},{-11.2,24}}, color = {0,0,127}, smooth = Smooth.None));
    connect(MinResistance1.y,division.u1) annotation(Line(points = {{25.5,71},{18,71},{18,86},{15,86}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end StaticDCDC_Conv;

  model VerySimpleDCDC_eqn
    parameter Real inQuiescentCurrent = 0.06
      "Input Current with No Output Load";
    parameter Modelica.SIunits.HeatCapacity HeatCap = 1
      "Heat capacity of element (= cp*m)";
    parameter Modelica.SIunits.ThermalConductance Gcond = 1
      "Constant thermal conductance of material";
    parameter Real vout = 28 "Target Voltage Output";
    Modelica.Electrical.Analog.Interfaces.PositivePin p
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                   annotation(Placement(transformation(extent = {{-106,36},{-90,52}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{-92,-6},{-104,6}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin p1
      "Positive pin (potential p.v > n.v for positive voltage drop v)"                                                    annotation(Placement(transformation(extent = {{108,32},{118,42}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n1 "Negative pin" annotation(Placement(transformation(extent = {{118,-24},{98,-4}}, rotation = 0)));
    //  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a HeatPort
    //    annotation (Placement(transformation(extent={{-10,-106},{10,-86}})));
  equation
    p.i + n.i = 0;
    p1.i + n1.i = 0;
    p1.v - n1.v = if 0 < p.v - n.v then vout else 0;
    p.i * (p.v - n.v) + p1.i * (p1.v - n1.v) = 0;
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics), Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end VerySimpleDCDC_eqn;

  model EPM "SImple EPM Coil Model with Resistors"
    Modelica.Electrical.Analog.Interfaces.PositivePin EPM0_P "positive pin" annotation(Placement(transformation(extent = {{-80,72},{-60,92}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin EPM0_N
      "Negative pin of the input port"                                                        annotation(Placement(transformation(extent = {{-80,44},{-60,64}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor EPMCoil(R = 10) annotation(Placement(transformation(extent = {{-44,72},{-24,92}})));
    Modelica.Electrical.Analog.Basic.Resistor EPMCoil1(R = 10) annotation(Placement(transformation(extent = {{-44,20},{-24,40}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin EPM1_P "positive pin" annotation(Placement(transformation(extent = {{-80,20},{-60,40}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin EPM1_N
      "Negative pin of the input port"                                                        annotation(Placement(transformation(extent = {{-80,-8},{-60,12}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor EPMCoil2(R = 10) annotation(Placement(transformation(extent = {{-44,-38},{-24,-18}})));
    Modelica.Electrical.Analog.Interfaces.PositivePin EPM2_P "positive pin" annotation(Placement(transformation(extent = {{-80,-38},{-60,-18}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin EPM2_N
      "Negative pin of the input port"                                                        annotation(Placement(transformation(extent = {{-80,-66},{-60,-46}}, rotation = 0)));
  equation
    connect(EPM0_P,EPMCoil.p) annotation(Line(points = {{-70,82},{-44,82}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EPMCoil.n,EPM0_N) annotation(Line(points = {{-24,82},{-18,82},{-18,54},{-70,54}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EPM1_P,EPMCoil1.p) annotation(Line(points = {{-70,30},{-44,30}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EPMCoil1.n,EPM1_N) annotation(Line(points = {{-24,30},{-18,30},{-18,2},{-70,2}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EPM2_P,EPMCoil2.p) annotation(Line(points = {{-70,-28},{-44,-28}}, color = {0,0,255}, smooth = Smooth.None));
    connect(EPMCoil2.n,EPM2_N) annotation(Line(points = {{-24,-28},{-18,-28},{-18,-56},{-70,-56}}, color = {0,0,255}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-100,-100},{100,100}}), graphics));
  end EPM;

  model DiffSignalGen
    parameter Real V = 5 "Amplitude of pulse";
    parameter Real width(final min = Modelica.Constants.small, final max = 100) = 50
      "Width of pulse in % of period";
    parameter Modelica.SIunits.Time period(final min = Modelica.Constants.small, start = 1)
      "Time for one period";
    parameter Integer nperiod = -1
      "Number of periods (< 0 means infinite number of periods)";
    parameter Real offset = 0 "Offset of output signals";
    parameter Modelica.SIunits.Time startTime = 0
      "Output = offset for time < startTime";
    Modelica.Blocks.Sources.Pulse pulse(amplitude = V, width = width, period = period, startTime = startTime) annotation(Placement(transformation(extent = {{-76,8},{-56,28}})));
    Modelica.Blocks.Math.Gain gain(k = -1) annotation(Placement(transformation(extent = {{-28,8},{-8,28}})));
    Modelica.Blocks.Math.Add add annotation(Placement(transformation(extent = {{18,0},{38,20}})));
    Modelica.Blocks.Sources.Constant const(k = V) annotation(Placement(transformation(extent = {{-42,-22},{-22,-2}})));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {64,-14})));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(transformation(extent = {{-10,-10},{10,10}}, rotation = -90, origin = {62,58})));
    Modelica.Electrical.Analog.Interfaces.PositivePin h annotation(Placement(transformation(extent = {{84,76},{104,96}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin n annotation(Placement(transformation(extent = {{104,-60},{84,-40}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin l annotation(Placement(transformation(extent = {{82,20},{102,40}}, rotation = 0)));
  equation
    connect(pulse.y,gain.u) annotation(Line(points = {{-55,18},{-30,18}}, color = {0,0,127}, smooth = Smooth.None));
    connect(gain.y,add.u1) annotation(Line(points = {{-7,18},{2,18},{2,16},{16,16}}, color = {0,0,127}, smooth = Smooth.None));
    connect(const.y,add.u2) annotation(Line(points = {{-21,-12},{-6,-12},{-6,4},{16,4}}, color = {0,0,127}, smooth = Smooth.None));
    connect(add.y,signalVoltage.v) annotation(Line(points = {{39,10},{76,10},{76,-14},{71,-14}}, color = {0,0,127}, smooth = Smooth.None));
    connect(h,signalVoltage1.p) annotation(Line(points = {{94,86},{62,86},{62,68}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.n,n) annotation(Line(points = {{64,-24},{64,-50},{94,-50}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage1.n,n) annotation(Line(points = {{62,48},{62,24},{46,24},{46,-50},{94,-50}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage.p,l) annotation(Line(points = {{64,-4},{92,-4},{92,30}}, color = {0,0,255}, smooth = Smooth.None));
    connect(signalVoltage1.v,gain.u) annotation(Line(points = {{69,58},{80,58},{80,76},{-42,76},{-42,18},{-30,18}}, color = {0,0,127}, smooth = Smooth.None));
    annotation(Diagram(coordinateSystem(preserveAspectRatio = false, extent = {{-80,-100},{100,100}}), graphics = {Line(points=  {{-98,-50},{-88,-50}}, color=  {160,160,164}),Line(points=  {{142,-50},{152,-50}}, color=  {160,160,164})}), Icon(coordinateSystem(extent = {{-80,-100},{100,100}})));
  end DiffSignalGen;
  annotation(uses(Modelica(version = "3.2")));
end tonka;
